---
title: Basic Example
slug: Web/XSLT/XSLT_JS_interface_in_Gecko/Basic_Example
tags:
  - XSLT
---
<h2 id="Basic_Example">Basic Example</h2>

<p>The basic example will load an XML file and apply a XSL transformation on it. These are the same files used in the <a href="/en-US/docs/XSLT_in_Gecko/Generating_HTML">Generating HTML</a> example in the <a href="/en-US/docs/XSLT_in_Gecko">XSLT in Netscape Gecko</a> article. The XML file describes an article and the XSL file formats the information for display.</p>

<p><small><strong>Figure 4 : XML file</strong></small></p>

<pre class="brush:xml;auto-links:false notranslate">&lt;?xml version="1.0"?&gt;
&lt;myNS:Article xmlns:myNS="http://devedge.netscape.com/2002/de"&gt;
  &lt;myNS:Title&gt;My Article&lt;/myNS:Title&gt;
  &lt;myNS:Authors&gt;
    &lt;myNS:Author company="Foopy Corp."&gt;Mr. Foo&lt;/myNS:Author&gt;
    &lt;myNS:Author&gt;Mr. Bar&lt;/myNS:Author&gt;
  &lt;/myNS:Authors&gt;
  &lt;myNS:Body&gt;
    The &lt;b&gt;rain&lt;/b&gt; in &lt;u&gt;Spain&lt;/u&gt; stays mainly in the plains.
  &lt;/myNS:Body&gt;
&lt;/myNS:Article&gt;</pre>

<p><small><strong>Figure 5 : XSLT Stylesheet</strong></small></p>

<pre class="brush:xml;auto-links:false notranslate">&lt;?xml version="1.0"?&gt;
&lt;xsl:stylesheet version="1.0"
                   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                   xmlns:myNS="http://devedge.netscape.com/2002/de"&gt;

  &lt;xsl:output method="html" /&gt;

  &lt;xsl:template match="/"&gt;
    &lt;html&gt;

      &lt;head&gt;

        &lt;title&gt;
          &lt;xsl:value-of select="/myNS:Article/myNS:Title"/&gt;
        &lt;/title&gt;

        &lt;style type="text/css"&gt;
          .myBox {margin:10px 155px 0 50px; border: 1px dotted #639ACE; padding:0 5px 0 5px;}
        &lt;/style&gt;

      &lt;/head&gt;

      &lt;body&gt;
        &lt;p class="myBox"&gt;
          &lt;span class="title"&gt;
            &lt;xsl:value-of select="/myNS:Article/myNS:Title"/&gt;
          &lt;/span&gt; &lt;br /&gt;

          Authors:   &lt;br /&gt;
            &lt;xsl:apply-templates select="/myNS:Article/myNS:Authors/myNS:Author"/&gt;
          &lt;/p&gt;

        &lt;p class="myBox"&gt;
          &lt;xsl:apply-templates select="//myNS:Body"/&gt;
        &lt;/p&gt;

      &lt;/body&gt;

    &lt;/html&gt;
  &lt;/xsl:template&gt;

  &lt;xsl:template match="myNS:Author"&gt;
     --   &lt;xsl:value-of select="." /&gt;

    &lt;xsl:if test="@company"&gt;
     ::   &lt;b&gt;  &lt;xsl:value-of select="@company" /&gt;  &lt;/b&gt;
    &lt;/xsl:if&gt;

    &lt;br /&gt;
  &lt;/xsl:template&gt;

  &lt;xsl:template match="myNS:Body"&gt;
    &lt;xsl:copy&gt;
      &lt;xsl:apply-templates select="@*|node()"/&gt;
    &lt;/xsl:copy&gt;
  &lt;/xsl:template&gt;

  &lt;xsl:template match="@*|node()"&gt;
      &lt;xsl:copy&gt;
        &lt;xsl:apply-templates select="@*|node()"/&gt;
      &lt;/xsl:copy&gt;
  &lt;/xsl:template&gt;
&lt;/xsl:stylesheet&gt;</pre>

<p>The example loads using synchronous {{domxref("XMLHTTPRequest")}} both the .xsl (<code>xslStylesheet</code>) and the .xml (<code>xmlDoc</code>) files into memory. The .xsl file is then imported (<code>xsltProcessor.importStylesheet(xslStylesheet)</code>) and the transformation run (<code>xsltProcessor.transformToFragment(xmlDoc, document)</code>). This allows fetching of data after the page has been loaded, without initiating a fresh page load.</p>

<p><small><strong>Figure 6 : Example</strong></small></p>

<pre class="brush:js notranslate">var xslStylesheet;
var xsltProcessor = new XSLTProcessor();
var myDOM;

var xmlDoc;

function Init(){

  // load the xslt file, example1.xsl
  var myXMLHTTPRequest = new XMLHttpRequest();
  myXMLHTTPRequest.open("GET", "example1.xsl", false);
  myXMLHTTPRequest.send(null);

  xslStylesheet = myXMLHTTPRequest.responseXML;
  xsltProcessor.importStylesheet(xslStylesheet);

  // load the xml file, example1.xml
  myXMLHTTPRequest = new XMLHttpRequest();
  myXMLHTTPRequest.open("GET", "example1.xml", false);
  myXMLHTTPRequest.send(null);

  xmlDoc = myXMLHTTPRequest.responseXML;

  var fragment = xsltProcessor.transformToFragment(xmlDoc, document);

  document.getElementById("example").textContent = "";

  myDOM = fragment;
  document.getElementById("example").appendChild(fragment);
}</pre>
